!to "bin/icc2019.prg",cbm

black         = $00
white         = $01
red           = $02
cyan          = $03
purple        = $04
green         = $05
blue          = $06
yellow        = $07
orange        = $08
brown         = $09
pink          = $0a
dark_grey     = $0b
grey          = $0c
light_green   = $0d
light_blue    = $0e
light_grey    = $0f

;*=$0801                    ; sets file load address to $0801
;   ;org $0801              ; sets compile address to $0801
;   !byte $0b,$08           ; Address of next BASIC instruction
;   !byte $DE,$07           ; Line number 2014
;   !byte $9e               ; SYS-token
;   !text " 9640"           ; 2062 in ASCII
;   !byte $00,$00,$00       ; BASIC program end
   
 *=$2000
!bin "bin/fontdata.bin"
start
  sei

;  lda #$7f
;  sta $dc0d  ;disable timer interrupts which can be generated by the two CIA chips
;  sta $dd0d  ;the kernal uses such an interrupt to flash the cursor and scan the keyboard, so we better
;             ;stop it.
;
;  lda $dc0d  ;by reading this two registers we negate any pending CIA irqs.
;  lda $dd0d  ;if we don't do this, a pending CIA irq might occur after we finish setting up our irq.
;             ;we don't want that to happen.
;
;  lda #$35   ;we turn off the BASIC and KERNAL rom here
;  sta $01    ;the cpu now sees RAM everywhere except at $d000-$e000, where still the registers of
;             ;SID/VICII/etc are visible


  lda #$06
  ldx #$ff             
-
  sta $d800-1+$67,x
  sta $d800-1+$67+$ff,x
  sta $d800-1+$67+$ff+$ff,x
  dex
  bne -
  
  ;lda #$00
  txa
  ldx #$67             
-
  sta $d800-1,x
  sta $d800-1+(18*40),x
  sta $d800-1+$67+(18*40),x
  sta $d800-1-$67+(25*40),x
  dex
  bne -

  sta $d020
  sta $d021
  
  jsr init_sid
  
loop:

;---------------------------------------------------
; After the Scroller
;---------------------------------------------------
  lda #$fb
wait_loop1:  
  cmp $d012
  bne wait_loop1

  jsr scroll
  ;$D018 = %xxxx100x -> charmem is at $2000
  ;$D018 = %1010xxxx -> screenmem is at $2800
  lda #%10101000
  sta $d018
  
  lda #%11101000
  sta $d016
  
;---------------------------------------------------
; After the Logo
;---------------------------------------------------
  lda #$c2
wait_loop2:
  cmp $d012
  bne wait_loop2

  ;$D018 = %xxxx010x -> charmem is at $1000
  ;$D018 = %1010xxxx -> screenmem is at $2800
  lda #%10100100
  sta $d018
  
d016_value = *+1
  lda #$07  
  sta $d016
  
  jsr play_sid
  
checkkey:
  lda $dc01
last_keydown = *+1  
  cmp #$00
  bne newkey
  lda #$ff      ;returns $ff in no change
  jmp no_key
newkey:
  sta last_keydown
  cmp #$ef      ;new key is spacebar
  beq key_space
no_key:
  
  jmp loop

key_space:
  lda #$7b
  sta $d011
  jmp $fce2
;  ;$D018 = %xxxx010x -> charmem is at $1000
;  ;$D018 = %0001xxxx -> screenmem is at $0400
;  lda #%00010100
;  sta $d018
;  
;  lda #%11101000
;  sta $d016  
;
;  lda #$0e
;  sta $d020
;  
;  lda #$06
;  sta $d021  
;  cli
;  
;  rts

!source "font_tiny.asm"

*= $2800  
screen

*= $2850
!bin "bin/screendata.bin"
  
;Character memory
;$D018 = %xxxx000x -> charmem is at $0000
;$D018 = %xxxx001x -> charmem is at $0800
;$D018 = %xxxx010x -> charmem is at $1000
;$D018 = %xxxx011x -> charmem is at $1800
;$D018 = %xxxx100x -> charmem is at $2000
;$D018 = %xxxx101x -> charmem is at $2800
;$D018 = %xxxx110x -> charmem is at $3000
;$D018 = %xxxx111x -> charmem is at $3800
;
;Screen memory
;$D018 = %0000xxxx -> screenmem is at $0000
;$D018 = %0001xxxx -> screenmem is at $0400
;$D018 = %0010xxxx -> screenmem is at $0800
;$D018 = %0011xxxx -> screenmem is at $0c00
;$D018 = %0100xxxx -> screenmem is at $1000
;$D018 = %0101xxxx -> screenmem is at $1400
;$D018 = %0110xxxx -> screenmem is at $1800
;$D018 = %0111xxxx -> screenmem is at $1c00
;$D018 = %1000xxxx -> screenmem is at $2000
;$D018 = %1001xxxx -> screenmem is at $2400
;$D018 = %1010xxxx -> screenmem is at $2800
;$D018 = %1011xxxx -> screenmem is at $2c00
;$D018 = %1100xxxx -> screenmem is at $3000
;$D018 = %1101xxxx -> screenmem is at $3400
;$D018 = %1110xxxx -> screenmem is at $3800
;$D018 = %1111xxxx -> screenmem is at $3c00

*=$2b70  
!source "scroller4x4.asm" 
!source "sound.asm"
!source "scrolltext.asm"


demo_end:
