!zone scroller
screenrmem = screen
colormem   = $d800

.first_line            = screenrmem + (18 * 40)
.second_line           = screenrmem + (19 * 40)
.third_line            = screenrmem + (20 * 40)
.fourth_line           = screenrmem + (21 * 40)

.color_first_line      = colormem + (18 * 40)
.color_second_line     = colormem + (19 * 40)
.color_third_line      = colormem + (20 * 40)
.color_fourth_line     = colormem + (21 * 40)

scroll:
  dec d016_value
  beq .hardscroll
  dec d016_value
  rts

.hardscroll
  lda #$07
  sta d016_value

  ldx #96
-         
  lda .first_line+1-96,x
  sta .first_line-96,x
  
  lda .color_first_line+1-96,x
  sta .color_first_line-96,x
  
  inx
  bne -

.text_start:
  jsr .current_txtpos
  cpy #$ff       ; end of txt ?          
  bne .continue     ; no
  ;jsr scroll_init
  
  lda #>scrolltext  ; textstart
  sta .current_txtpos+2
  lda #<scrolltext
  sta .current_txtpos+1
  
  jmp .text_start

.adc_value ;muliple of the implemented chars
!byte 90, 45, 0 

.continue:
  dec .sub_char
.sub_char = *+1  
  lda #$03          
  cmp #$ff
  bne +
  jmp .zero
+ 
  tax
  tya
  clc
  adc .adc_value,x ;implemented chars
  tay    
  
.current_color_scheme = *+1
  ldx #$01
  lda .scheme_color_table0-1,x
  sta .color_first_line+39
  lda .scheme_color_table1-1,x
  sta .color_second_line+39
  lda .scheme_color_table2-1,x
  sta .color_third_line+39
  lda .scheme_color_table3-1,x
  sta .color_fourth_line+39

.print    
  lda table_0_0,y
  sta .first_line+39
  lda table_1_0,y
  sta .second_line+39
  lda table_2_0,y
  sta .third_line+39
  lda table_3_0,y
  sta .fourth_line+39
  
  rts

.zero         
  lda #$03
  sta .sub_char
  
  ldy #$00 ; last char is SPACE for all chars
  jsr .print 
          
.next_char          
  inc .current_txtpos+1
  bne +
  inc .current_txtpos+2
  lda .current_txtpos+2
+          
  jsr .current_txtpos

  cpy #$00 ;make space smaller
  bne ++
  dec .current_color_scheme
  bne +
  lda #$04
  sta .current_color_scheme
+         
  lda #$01
  jmp .set_charlength_with_a
++        
;+         
  cpy #45 ;set space without colorchange for the underscore _
  bne +
  lda #$01
  jmp .set_charlength_with_a
          
+         
  cpy #$fb ;set color 3
  bne +
  lda #$04
  sta .current_color_scheme
  jmp .next_char

+         
  cpy #$fc ;set color 2
  bne +
  lda #$03
  sta .current_color_scheme
  jmp .next_char
        
+         
  cpy #$fd ;set color 1
  bne +
  lda #$02
  sta .current_color_scheme
  jmp .next_char

+         
  cpy #$fe ;set color 0
  bne +
  lda #$01
  sta .current_color_scheme
  jmp .next_char

+          
.set_charlength:
  lda #$03
.set_charlength_with_a:  
  sta .sub_char          
  rts

.current_txtpos:
  ldy scrolltext ;will be selfmodded !
  rts        

.scheme_color_table0:
  !byte white, yellow, light_grey, yellow
.scheme_color_table1:
  !byte light_grey, pink, cyan, light_green
.scheme_color_table2:
  !byte grey, orange, light_blue, light_grey
.scheme_color_table3:
  !byte dark_grey,red, blue, green